# Euklidův algoritmus je algoritmus, kterým lze určit největší společný dělitel 
# dvou přirozených čísel, tedy největší číslo takové, že beze zbytku dělí obě čísla.

# Realizace algoritmu na papíře:
# 1. Do levého sloupce zapíšeme větší ze dvou čísel, do pravého sloupce menší.
# 2. Na každý další řádek: doleva opíšeme pravé číslo z předchozího řádku, 
#    doprava zapíšeme zbytek po dělení dvou čísel z předchozího řádku.
# 3. Když v pravém sloupci bude zapsaná 0, skončili jsme a v levém sloupci máme výsledek.
 
# Příklad: Počítáme největší společný dělitel čísel 25 a 85:
#  85  25    (doleva větší, doprava menší)
#  25  10    (doleva opíšeme 25, doprava zapíšeme zbytek po dělení 85 25, tj. 10)
#  10   5    (doleva opíšeme 10, doprava zapíšeme zbytek po dělení 25 10, tj. 5)
#   5   0    (doleva opíšeme 5, doprava zapíšeme zbytek po dělení 10 5, tj. 0)
# Vpravo máme 0, tj. výsledek (největší společný dělitel 25 a 85) je 5.


# Následuje program, který implementuje Euklidův algoritmus:

# Načítání vstupu a konverze na čísla:
numbers = input('Zadejte dvě přirozená čísla oddělená mezerou: ')
a, b = numbers.split()
a = int(a)
b = int(b)

# Do a vkládáme větší (levý sloupec), do b menší číslo (pravý sloupec):
if a < b:
    a, b = b, a

# Dělíme až dokud nedostaneme vpravo nulu:
while b != 0:
    a, b = b, a % b

# Výsledek máme v levém sloupci:
result = a

# Výpis:
print(f'Největší společný dělitel je {result}.')
